/* ***************************************************************************
   *  Kindermann                                 WPK Produktentwicklung      *
   *                                             Schuljahr: 2010/11          *
   *                                                                         *
   *                            Pacman VGA 25MHz                             *
   *                                                                         *
   *    Dieses Programm basiert auf dem AVGA Project von Jaromir Dvorak      *
   *    (http://avga.prometheus4.com/) sowie der Pacman-Version von Albert   *
   *    Seward.                                                              *
   *                                                                         *
   *    Es kann unter den Bedingungen der GNU General Public License (GPL)   *
   *    weitergeben und/oder modifiziert werden.                             *
   *                                                                         *
   ***************************************************************************/


#include <stdio.h>
#include "../avga.h"

#include <avr/eeprom.h>
#include <string.h>
#include "../core/video.h"
#include "../core/driver.h"
#include "../../tetris.h"


static unsigned int _rand = 1;

uint8_t misc_rand() {
	return ((_rand = _rand * 1103515245L + 12345L) % 255);
}

void utoa10(uint16_t num, uint8_t *str) {

	uint16_t tmp;

	*(str++) = '0';
	*(str++) = '0';
	*(str++) = '0';
	*(str++) = '0';
	*(str) = '0';

	do {
		tmp = num / 10;
		*(str--) = '0' + num - tmp * 10;
		num = tmp;
	} while(num);

}


void key_init(void) {
 	KEY_DDR &= ~KEY_ANY;
	KEY_PORT |= KEY_ANY;
}


uint8_t key_wait_timeout(uint8_t mask, uint8_t timeout) {
	uint8_t i;
	for(i = 0; (i < timeout) && !key_read(mask); i++) {
		sync();
		sync();
	}
	return i != timeout;
}

